#include "stdio_fp11.h"
#include "d_fp1101p0.h"

#define MAXNUM 255

unsigned char sieve[MAXNUM / 8];

unsigned char m2;
unsigned int j;
unsigned char i, k, m;
unsigned char ah, bh, zh, n, op, led, btn;

void main() {
	pb2dfu_set(C_PBP_REG01, 0);
	op = mb2pb_read_data();
	if (op == C_DFU_OP_VVER) {
		pb2dfu_set(C_DFU_CNT, 0);
		pb2dfu_set(C_DFU_OP, op);
		pb2dfu_wait4hw();
	} else {
		pb2dfu_set(C_DFU_A_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_A_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_SADDR, mb2pb_read_data());
		ah = mb2pb_read_data();
		pb2dfu_set(C_DFU_A_MEM_BANK, ah);
		bh = mb2pb_read_data();
		pb2dfu_set(C_DFU_B_MEM_BANK, bh);
		zh = mb2pb_read_data();
		pb2dfu_set(C_DFU_Z_MEM_BANK, zh);
		pb2dfu_set(C_DFU_A_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_INC, mb2pb_read_data());
		n = mb2pb_read_data() - 1;
		pb2dfu_set(C_DFU_CNT, n);

		pb2dfu_set(C_DFU_OP, op);
		{
			m = (((ah << 4) + (bh << 2) + 3) << 2);
			if ((m != m2) & (m < MAXNUM)) {
				for (i = 0; i < (m >> 3); ++i) {
					sieve[i] = 0;
				}
				for (i = 2;; ++i) {
					for (; i < m; ++i) {
						if (getv(sieve, i) == 0) {
							break;
						}
					}
					if (i == m) {
						break;
					} else {
						for (j = (unsigned int) (((unsigned int) 2)
								* ((unsigned int) i)); j < (unsigned int) m;
								j += (unsigned int) i) {
							setv(sieve, (unsigned char) j);
						}
					}
				}
			}
		}
		pb2dfu_wait4hw();

		led = led2pb();
		btn = btn2pb();

		pb2mb_write(C_SCREEN_2);
		{
			if ((m != m2) & (m < MAXNUM)) {
				m2 = m;
				pb2mb_write('\n');
				pb2mb_write(hex_h(m));
				pb2mb_write(hex_l(m));
				pb2mb_write(':');
				pb2mb_write(' ');
				for (i = 2; i < m; ++i) {
					k = 1;
					k = getv(sieve, i);
					if (k == 0) {
						pb2mb_write(hex_h(i));
						pb2mb_write(hex_l(i));
						pb2mb_write(' ');
					}
				}
			}
		}
		pb2mb_eoc(led);

		pb2mb_write(C_SCREEN_0);
		pb2mb_eoc(led);
	}
	pb2mb_eoc('.');
	pb2mb_req_reset('.');
	pb2mb_reset();
}

