#include "stdio_fp11.h"
#include "e_fp1101p0.h"

#define MAXNUM 320

unsigned char sieve[MAXNUM / 8];

unsigned int i, j, m, m2;
unsigned char k;
unsigned char ah, bh, zh, n, op, led, btn;

void main() {
	pb2dfu_set(C_PBP_REG01, 0);
	op = mb2pb_read_data();
	if (op == C_DFU_OP_VVER) {
		pb2dfu_set(C_DFU_CNT, 0);
		pb2dfu_set(C_DFU_OP, op);
		pb2dfu_wait4hw();
	} else {
		pb2dfu_set(C_DFU_A_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_A_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_MEM_SADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_ADDR, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_MEM_SADDR, mb2pb_read_data());
		ah = mb2pb_read_data();
		pb2dfu_set(C_DFU_A_MEM_BANK, ah);
		bh = mb2pb_read_data();
		pb2dfu_set(C_DFU_B_MEM_BANK, bh);
		zh = mb2pb_read_data();
		pb2dfu_set(C_DFU_Z_MEM_BANK, zh);
		pb2dfu_set(C_DFU_A_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_B_INC, mb2pb_read_data());
		pb2dfu_set(C_DFU_Z_INC, mb2pb_read_data());
		n = mb2pb_read_data() - 1;
		pb2dfu_set(C_DFU_CNT, n);

		pb2dfu_set(C_DFU_OP, op);
		{
			m = ((unsigned int) ((ah << 4) + (bh << 2) + zh + 17)) << 2;
			if ((m != m2) && (m < MAXNUM)) {
				for (k = 0; k < (unsigned char) (m >> 3); ++k) {
					sieve[k] = 0;
				}
				for (i = 2;; ++i) {
					for (; i < m; ++i) {
						if (getv(sieve, i) == 0) {
							break;
						}
					}
					if (i == m) {
						break;
					} else {
						for (j = (2 * i); j < m; j += i) {
							setv(sieve, j);
						}
					}
				}
			}
		}
		pb2dfu_wait4hw();

		led = led2pb();
		btn = btn2pb();

		pb2mb_write(C_SCREEN_2);
		{
			if ((m != m2) && (m < MAXNUM)) {
				m2 = m;
				pb2mb_write('\n');
				if (m > 255)
					pb2mb_write('1');
				k = (unsigned char) (m & 0xFF);
				pb2mb_write(hex_h(k));
				pb2mb_write(hex_l(k));
				pb2mb_write(':');
				pb2mb_write(' ');
				for (i = 2; i < m; ++i) {
					k = 1;
					k = getv(sieve, i);
					if (k == 0) {
						if (i > 255)
							pb2mb_write('1');
						k = (unsigned char) (i & 0xFF);
						pb2mb_write(hex_h(k));
						pb2mb_write(hex_l(k));
						pb2mb_write(' ');
					}
				}
			}
		}
		pb2mb_eoc(led);

		pb2mb_write(C_SCREEN_0);
		pb2mb_eoc(led);
	}
	pb2mb_eoc('.');
	pb2mb_req_reset('.');
	pb2mb_reset();
}

