// DISCLAIMER OF LIABILITY
// 
// This text/file contains proprietary, confidential
// information of Xilinx, Inc., is distributed under license
// from Xilinx, Inc., and may be used, copied and/or
// disclosed only pursuant to the terms of a valid license
// agreement with Xilinx, Inc. Xilinx hereby grants you a 
// license to use this text/file solely for design, simulation, 
// implementation and creation of design files limited 
// to Xilinx devices or technologies. Use with non-Xilinx 
// devices or technologies is expressly prohibited and 
// immediately terminates your license unless covered by
// a separate agreement.
//
// Xilinx is providing this design, code, or information 
// "as-is" solely for use in developing programs and 
// solutions for Xilinx devices, with no obligation on the 
// part of Xilinx to provide support. By providing this design, 
// code, or information as one possible implementation of 
// this feature, application or standard, Xilinx is making no 
// representation that this implementation is free from any 
// claims of infringement. You are responsible for 
// obtaining any rights you may require for your implementation. 
// Xilinx expressly disclaims any warranty whatsoever with 
// respect to the adequacy of the implementation, including 
// but not limited to any warranties or representations that this
// implementation is free from claims of infringement, implied 
// warranties of merchantability or fitness for a particular 
// purpose.
//
// Xilinx products are not intended for use in life support
// appliances, devices, or systems. Use in such applications is
// expressly prohibited.
//
// Any modifications that are made to the Source Code are 
// done at the users sole risk and will be unsupported.
//
//
// Copyright (c) 2007, 2008 Xilinx, Inc. All rights reserved.
//
// This copyright and support notice must be retained as part 
// of this text at all times. 
//
//******************************************************************************/
// Filename            : fir_2d.h
// $Revision:: 3507   $: Revision of last commit
// $Date:: 2008-09-04#$: Date of last commit
// Description         : Header file of constants for RGB 2D FIR Menu
//******************************************************************************/

#ifndef __fir_2d__
#define __fir_2d__
 
#include <stdio.h>

// Located in: microblaze_0/include/
#include "xutil.h"
#include "xparameters.h"

//#include "rgb_2d_fir_sp605_plbw.h"

#ifdef NOTNOW
#define RGB_2D_FIR_ID XPAR_RGB_2D_FIR_SP605_DEVICE_ID
#else
#define RGB_2D_FIR_ID XPAR_FIR_3X3_DEVICE_ID
#endif
#define RGB_2D_FIR_PLBW_ConfigTable RGB_2D_FIR_SP605_PLBW_ConfigTable

void vsk_load_fir_2d(Xint32);
void vsk_load_fir_identity(void);

void vsk_load_fir_2d_coefficients(int *);
void vsk_set_fir_2d_coefficients(void);
void vsk_read_fir_2d_coefficients(Xint32);

void vsk_load_fir_2d_gain(Xint32);
void vsk_step_fir_2d_gain(Xint32);
void vsk_read_fir_2d_gain(void);

void vsk_disable_fir_2d_coef_update(void);
void vsk_enable_fir_2d_coef_update(void);

extern volatile int autocoeff_continue;
void vsk_load_fir_auto(void);


void vsk_fir_2d_main (void);

Xfloat64 UFix20_17_to_double(Xuint32);
Xuint32 double_to_UFix20_17(Xfloat64);
void print_UFix20_17(Xuint32);
 
Xint32 signExtInt(Xint32,Xint32);

#define INPUTBUFSIZE 24
void getString(Xuint8*);

#endif
